"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Fetch_1 = require("./Fetch");
const Fs = require("fs");
(() => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    // echo test
    try {
        const testText = "hello", t = new Date().getTime(), json = yield new Fetch_1.Fetch("https://postman-echo.com/post").head("X-Time", t).fetch(testText, "text/plain"), obj = JSON.parse(json);
        if (!obj)
            console.log("empty response");
        else {
            if (obj.data !== testText)
                console.error("invalid data");
            else {
                if (!obj.headers || obj.headers["x-time"] != t)
                    console.error("invalid header");
                else
                    console.info("all ok");
            }
        }
    }
    catch (ex) {
        console.error(`exception: ${ex.message || ex}`);
    }
    // error test
    try {
        yield new Fetch_1.Fetch("https://postman-echo.com/status/500").fetch();
    }
    catch (ex) {
        if (ex.statusCode !== 500)
            console.error("error test failed");
        else
            console.info("error test ok");
    }
    // error map
    try {
        yield new Fetch_1.Fetch("https://postman-echo.com/status/500")
            .exMap((ex, data) => {
            if (data && data === "{\"status\":500}")
                return new Error("mapping ok");
            return ex;
        })
            .fetch();
    }
    catch (ex) {
        if (ex.message === "mapping ok")
            console.info("error map test ok");
        else
            console.error("error map test failed");
    }
    // basic auth test
    try {
        const json = yield new Fetch_1.Fetch("https://postman-echo.com/basic-auth").basicAuth("postman", "password").fetch(), obj = JSON.parse(json);
        if (obj && obj.authenticated === true)
            console.info("basic auth ok");
        else
            console.error("basic auth failed");
    }
    catch (ex) {
        console.error(`exception: ${ex.message || ex}`);
    }
    // stream test
    try {
        const stream = Fs.createWriteStream("out.txt");
        yield new Fetch_1.Fetch("https://postman-echo.com/stream/5").pipe(stream);
        console.info("stream ok");
    }
    catch (ex) {
        console.error(`exception: ${ex.message || ex}`);
    }
    // timeout
    try {
        yield new Fetch_1.Fetch("https://postman-echo.com/delay/10").timeout(1000).fetch();
        console.error("timeout failed");
    }
    catch (ex) {
        if ((_a = ex.message) === null || _a === void 0 ? void 0 : _a.includes("timeout"))
            console.info("timeout ok");
        else
            console.error("got timeout, but invalid ex");
    }
    // temp. redirect test (307)
}))();
//# sourceMappingURL=Test.js.map